from Plasma import *
from PlasmaTypes import *
from PlasmaKITypes import *
from PlasmaVaultConstants import *
from PlasmaNetConstants import *
import xLocalization
import string
import time
DoorStateClosed = 0
DoorStateOpen = 1
DoorStateClosing = 2
DoorStateOpening = 3
actClickableObject = ptAttribActivator(1, 'Act: Clickable Object')
ObjectMsg = ptAttribString(2, 'Object String')
respDoor = ptAttribResponder(3, 'Door sound responder')
class Dragons_toothHutdoorclick(ptModifier,):
    __module__ = __name__
    __module__ = __name__
    __module__ = __name__
    __module__ = __name__
    __module__ = __name__
    __module__ = __name__

    def __init__(self):
        ptModifier.__init__(self)
        self.id = 100110003
        self.version = 2
        self.AgeName = None
        self.AgeSDL = None
        self.doorcollider = None
        self.activedoor = None
        self.StartTime = 0
        self.DoorState = DoorStateClosed
        self.XWidth = 23.914999999999999
        self.XClosedPos = 503.37599999999998
        self.XOpenPos = (self.XClosedPos + self.XWidth)
        self.DoorTimerInterval = 0.029999999999999999
        self.DoorOpenTimerId = 1
        self.DoorCloseTimerId = 2
        self.DoorMoveDuration = 4.0
        self.DelayInterval = 3.0
        self.DelayTimerId = 3
        print ('__init__%s v.%s' % (self.__class__.__name__,
         self.version,))



    def OnFirstUpdate(self):
        self.AgeName = PtGetAgeName()
        self.AgeSDL = PtGetAgeSDL()



    def OnServerInitComplete(self):
        if (self.AgeSDL != None):
            self.DoorState = self.AgeSDL['HutactivedoorOpen'][0]
        else:
            print 'ERROR: Missing SDL - default closed door'
        self.doorcollider = PtFindSceneobject('Hutdoorcollider', self.AgeName)
        if (self.doorcollider != None):
            if (self.DoorState == DoorStateOpen):
                print 'door was open - disable collider'
                self.doorcollider.physics.suppress(true)
        else:
            print 'OnServerInitComplete - could not find doorcollider!'
        self.activedoor = PtFindSceneobject('Hutactivedoor', self.AgeName)
        if (self.activedoor != None):
            self.activedoor.physics.suppress(true)
            if (self.DoorState == DoorStateOpen):
                print 'door was open - set to open position'
                oldPos = self.activedoor.position()
                newPos = ptPoint3(self.XOpenPos, oldPos.getY(), oldPos.getZ())
                self.activedoor.physics.warp(newPos)
        else:
            print 'OnServerInitComplete - could not find activedoor!'



    def OnNotify(self, state, id, events):
        print 'OnNotfiy: id=',
        print id
        print 'ID of Clickable logicmod:',
        print actClickableObject.id
        if ((id == actClickableObject.id) and state):
            print 'Message:',
            print ObjectMsg
            print ("Value of message: '%s'" % ObjectMsg.value)
            respDoor.run(self.key, netPropagate=0)
            actClickableObject.disable()
            self.DoorState = self.AgeSDL['HutactivedoorOpen'][0]
            PtAtTimeCallback(self.key, self.DelayInterval, self.DelayTimerId)



    def OnTimer(self, id):
        if (id == self.DelayTimerId):
            if ((ObjectMsg.value == 'Hutdoorbutton') and (self.activedoor != None)):
                print 'Processing activedoor'
                if (self.DoorState == DoorStateOpen):
                    self.StartTime = time.clock()
                    self.DoorState = DoorStateClosing
                    self.doorcollider.physics.suppress(false)
                    PtAtTimeCallback(self.key, self.DoorTimerInterval, self.DoorCloseTimerId)
                elif (self.DoorState == DoorStateClosed):
                    self.StartTime = time.clock()
                    self.DoorState = DoorStateOpening
                    PtAtTimeCallback(self.key, self.DoorTimerInterval, self.DoorOpenTimerId)
        elif (id == self.DoorOpenTimerId):
            currentTime = time.clock()
            xPos = (self.XClosedPos + (((currentTime - self.StartTime) / self.DoorMoveDuration) * self.XWidth))
            oldPos = self.activedoor.position()
            newPos = ptPoint3(xPos, oldPos.getY(), oldPos.getZ())
            self.activedoor.physics.warp(newPos)
            if (xPos >= self.XOpenPos):
                self.DoorState = DoorStateOpen
                actClickableObject.enable()
                self.doorcollider.physics.suppress(true)
                if PtWasLocallyNotified(self.key):
                    self.AgeSDL['HutactivedoorOpen'] = (self.DoorState,)
            else:
                PtAtTimeCallback(self.key, self.DoorTimerInterval, self.DoorOpenTimerId)
        elif (id == self.DoorCloseTimerId):
            currentTime = time.clock()
            xPos = (self.XOpenPos - (((currentTime - self.StartTime) / self.DoorMoveDuration) * self.XWidth))
            oldPos = self.activedoor.position()
            newPos = ptPoint3(xPos, oldPos.getY(), oldPos.getZ())
            self.activedoor.physics.warp(newPos)
            if (xPos <= self.XClosedPos):
                self.DoorState = DoorStateClosed
                actClickableObject.enable()
                if PtWasLocallyNotified(self.key):
                    self.AgeSDL['HutactivedoorOpen'] = (self.DoorState,)
            else:
                PtAtTimeCallback(self.key, self.DoorTimerInterval, self.DoorCloseTimerId)



glue_cl = None
glue_inst = None
glue_params = None
glue_paramKeys = None
try:
    x = glue_verbose
except NameError:
    glue_verbose = 0

def glue_getClass():
    global glue_cl
    if (glue_cl == None):
        try:
            cl = eval(glue_name)
            if issubclass(cl, ptModifier):
                glue_cl = cl
            elif glue_verbose:
                print ('Class %s is not derived from modifier' % cl.__name__)
        except NameError:
            if glue_verbose:
                try:
                    print ('Could not find class %s' % glue_name)
                except NameError:
                    print 'Filename/classname not set!'
    return glue_cl



def glue_getInst():
    global glue_inst
    if (type(glue_inst) == type(None)):
        cl = glue_getClass()
        if (cl != None):
            glue_inst = cl()
    return glue_inst



def glue_delInst():
    global glue_inst
    global glue_cl
    global glue_paramKeys
    global glue_params
    if (type(glue_inst) != type(None)):
        del glue_inst
    glue_cl = None
    glue_params = None
    glue_paramKeys = None



def glue_getVersion():
    inst = glue_getInst()
    ver = inst.version
    glue_delInst()
    return ver



def glue_findAndAddAttribs(obj, glue_params):
    if isinstance(obj, ptAttribute):
        if glue_params.has_key(obj.id):
            if glue_verbose:
                print 'WARNING: Duplicate attribute ids!'
                print ('%s has id %d which is already defined in %s' % (obj.name,
                 obj.id,
                 glue_params[obj.id].name,))
        else:
            glue_params[obj.id] = obj
    elif (type(obj) == type([])):
        for o in obj:
            glue_findAndAddAttribs(o, glue_params)

    elif (type(obj) == type({})):
        for o in obj.values():
            glue_findAndAddAttribs(o, glue_params)




def glue_getParamDict():
    global glue_paramKeys
    global glue_params
    if (type(glue_params) == type(None)):
        glue_params = {}
        gd = globals()
        for obj in gd.values():
            glue_findAndAddAttribs(obj, glue_params)

        glue_paramKeys = glue_params.keys()
        glue_paramKeys.sort()
        glue_paramKeys.reverse()
    return glue_params



def glue_getClassName():
    cl = glue_getClass()
    if (cl != None):
        return cl.__name__
    if glue_verbose:
        print ('Class not found in %s.py' % glue_name)
    return None



def glue_getBlockID():
    inst = glue_getInst()
    if (inst != None):
        return inst.id
    if glue_verbose:
        print ('Instance could not be created in %s.py' % glue_name)
    return None



def glue_getNumParams():
    pd = glue_getParamDict()
    if (pd != None):
        return len(pd)
    if glue_verbose:
        print ('No attributes found in %s.py' % glue_name)
    return 0



def glue_getParam(number):
    pd = glue_getParamDict()
    if (pd != None):
        if (type(glue_paramKeys) == type([])):
            if ((number >= 0) and (number < len(glue_paramKeys))):
                return pd[glue_paramKeys[number]].getdef()
            else:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if ((number >= 0) and (number < len(pl))):
                return pl[number].getdef()
            elif glue_verbose:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None



def glue_setParam(id, value):
    pd = glue_getParamDict()
    if (pd != None):
        if pd.has_key(id):
            try:
                pd[id].__setvalue__(value)
            except AttributeError:
                if isinstance(pd[id], ptAttributeList):
                    try:
                        if (type(pd[id].value) != type([])):
                            pd[id].value = []
                    except AttributeError:
                        pd[id].value = []
                    pd[id].value.append(value)
                else:
                    pd[id].value = value
        elif glue_verbose:
            print "setParam: can't find id=",
            print id
    else:
        print 'setParma: Something terribly has gone wrong. Head for the cover.'



def glue_isNamedAttribute(id):
    pd = glue_getParamDict()
    if (pd != None):
        try:
            if isinstance(pd[id], ptAttribNamedActivator):
                return 1
            if isinstance(pd[id], ptAttribNamedResponder):
                return 2
        except KeyError:
            if glue_verbose:
                print ('Could not find id=%d attribute' % id)
    return 0



def glue_isMultiModifier():
    inst = glue_getInst()
    if isinstance(inst, ptMultiModifier):
        return 1
    return 0



def glue_getVisInfo(number):
    pd = glue_getParamDict()
    if (pd != None):
        if (type(glue_paramKeys) == type([])):
            if ((number >= 0) and (number < len(glue_paramKeys))):
                return pd[glue_paramKeys[number]].getVisInfo()
            else:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if ((number >= 0) and (number < len(pl))):
                return pl[number].getVisInfo()
            elif glue_verbose:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None



